diff --git a/src/main/java/net/minecraft/client/gui/GuiSlider.java b/src/main/java/net/minecraft/client/gui/SliderElement.java
similarity index 82%
rename from src/main/java/net/minecraft/client/gui/GuiSlider.java
rename to src/main/java/net/minecraft/client/gui/SliderElement.java
index f449b25f7..9758b52a2 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSlider.java
+++ b/src/main/java/net/minecraft/client/gui/SliderElement.java
@@ -1,30 +1,30 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.FloatOption;
 
-public class GuiSlider extends GuiButton {
+public class SliderElement extends ButtonElement {
 
 	public float sliderValue;
 	public boolean dragging;
 	private FloatOption option;
 
-	public GuiSlider(int id, int xPosition, int yPosition, FloatOption floatOption) {
+	public SliderElement(int id, int xPosition, int yPosition, FloatOption floatOption) {
 		this(id, xPosition, yPosition, 150, 20, floatOption);
 	}
 
-	public GuiSlider(int id, int xPosition, int yPosition, int width, int height, FloatOption floatOption) {
+	public SliderElement(int id, int xPosition, int yPosition, int width, int height, FloatOption floatOption) {
 		super(id, xPosition, yPosition, width, height, floatOption.getDisplayStringValue());
 		this.dragging = false;
 		this.option = floatOption;
 		this.sliderValue = floatOption.value;
 	}
 
-	public GuiSlider(int id, int xPosition, int yPosition, int width, int height, String text, float defaultValue) {
+	public SliderElement(int id, int xPosition, int yPosition, int width, int height, String text, float defaultValue) {
 		super(id, xPosition, yPosition, width, height, text);
 		dragging = false;
 		option = null;
@@ -55,7 +55,7 @@ public class GuiSlider extends GuiButton {
 	{
 		if (!visible) return;
 
-		FontRenderer fontrenderer = mc.fontRenderer;
+		Font font = mc.font;
 		boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
 		int state = getButtonState(mouseOver);
 
@@ -94,7 +94,7 @@ public class GuiSlider extends GuiButton {
 				textColor = 0xFFFFA0;
 				break;
 		}
-		drawStringCentered(fontrenderer, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
+		drawStringCentered(font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/gui/GuiSoundTest.java b/src/main/java/net/minecraft/client/gui/SoundTestScreen.java
similarity index 63%
rename from src/main/java/net/minecraft/client/gui/GuiSoundTest.java
rename to src/main/java/net/minecraft/client/gui/SoundTestScreen.java
index d9ecefd6a..ef3028ffb 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSoundTest.java
+++ b/src/main/java/net/minecraft/client/gui/SoundTestScreen.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
+import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.sound.SoundEngine;
@@ -18,7 +18,7 @@ import java.io.File;
 import java.util.ArrayList;
 import java.util.List;
 
-public class GuiSoundTest extends GuiScreen{
+public class SoundTestScreen extends Screen {
     private static final int TOP_SPACING = 24;
     private static final int BUTTON_SPACING = 4;
 
@@ -29,14 +29,14 @@ public class GuiSoundTest extends GuiScreen{
     protected @Nullable SoundEvent currentEntry;
     protected List<SoundEvent> allEntries;
 
-    protected GuiListenerButton leftEntry;
+    protected ListenerButtonElement leftEntry;
 
     protected float volume = 1;
     protected float pitch = 1;
 
     protected boolean showURL = true;
 
-    public GuiSoundTest(GuiScreen parent) {
+    public SoundTestScreen(Screen parent) {
         super(parent);
         initRepos();
     }
@@ -48,24 +48,24 @@ public class GuiSoundTest extends GuiScreen{
         entryIndex = 0;
     }
     @Override
-    public void keyTyped(char c, int key, int mouseX, int mouseY)
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-        if (key == Keyboard.KEY_ESCAPE) {
-            mc.displayGuiScreen(parentScreen);
+        if (eventKey == Keyboard.KEY_ESCAPE) {
+            mc.displayScreen(parentScreen);
         }
-        List<GuiButton> _buttons = new ArrayList<>(controlList);
-        for (GuiButton button : _buttons){
-            if (button instanceof IListenerElement && button.isHovered(mouseX, mouseY)){
-                ((IListenerElement) button).onKeyTyped(c, key);
+        List<ButtonElement> _buttons = new ArrayList<>(buttons);
+        for (ButtonElement button : _buttons){
+            if (button instanceof IListenerElement && button.isHovered(mx, my)){
+                ((IListenerElement) button).onKeyTyped(eventCharacter, eventKey);
             }
         }
     }
     @Override
     public void tick(){
-        List<GuiButton> _buttons = new ArrayList<>(controlList);
-        for (GuiButton button : _buttons){
-            if (button instanceof GuiListenerButton){
-                ((GuiListenerButton) button).tick();
+        List<ButtonElement> _buttons = new ArrayList<>(buttons);
+        for (ButtonElement button : _buttons){
+            if (button instanceof ListenerButtonElement){
+                ((ListenerButtonElement) button).tick();
             }
         }
     }
@@ -74,40 +74,40 @@ public class GuiSoundTest extends GuiScreen{
 
         top = TOP_SPACING;
         bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
-        add(new GuiListenerButton(0, width/2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.sound_test.button.done")).setActionListener(() -> {
-            onClosed();
-            mc.displayGuiScreen(null);
+        add(new ListenerButtonElement(0, width/2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.sound_test.button.done")).setActionListener(() -> {
+            removed();
+            mc.displayScreen(null);
         }));
 
-        leftEntry = add(new GuiListenerButton(11, width - (20 + BUTTON_SPACING) * 2, bottom - (BUTTON_SPACING + 20) * 2, 20, 20, "<")
+        leftEntry = add(new ListenerButtonElement(11, width - (20 + BUTTON_SPACING) * 2, bottom - (BUTTON_SPACING + 20) * 2, 20, 20, "<")
             .setActionListener(() -> cycleEntry(-1)));
-        add(new GuiListenerButton(12, width - (20 + BUTTON_SPACING) * 1, bottom - (BUTTON_SPACING + 20) * 2, 20, 20, ">")
+        add(new ListenerButtonElement(12, width - (20 + BUTTON_SPACING) * 1, bottom - (BUTTON_SPACING + 20) * 2, 20, 20, ">")
             .setActionListener(() -> cycleEntry(1)));
 
-        GuiListenerButton b = add(new GuiListenerButton(20, width/2 - 100, bottom - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.sound_test.button.play"))
+        ListenerButtonElement b = add(new ListenerButtonElement(20, width/2 - 100, bottom - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.sound_test.button.play"))
             .setActionListener(this::playEntry)
         );
         b.playSound = false;
-        add(new GuiListenerButton(22, width/2 + 100 + BUTTON_SPACING, bottom - (BUTTON_SPACING + 20), 20, 20, "X")
+        add(new ListenerButtonElement(22, width/2 + 100 + BUTTON_SPACING, bottom - (BUTTON_SPACING + 20), 20, 20, "X")
             .setActionListener(this::stopSound)
         );
 
 
-        add(new GuiListenerButton(30, BUTTON_SPACING, bottom - (BUTTON_SPACING + 20), 20, 20, "")
+        add(new ListenerButtonElement(30, BUTTON_SPACING, bottom - (BUTTON_SPACING + 20), 20, 20, "")
             .setActionListener(() -> Utils.openDirectory(new File(mc.getMinecraftDir(), "resources")))
             .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder"));
 
-        add(new GuiListenerButton(31, 20 + BUTTON_SPACING * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "V"))
+        add(new ListenerButtonElement(31, 20 + BUTTON_SPACING * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "V"))
             .setActionListener(() -> showURL = !showURL);
 
-        add(new GuiListenerButton(32, 40 + BUTTON_SPACING * 3, bottom - (BUTTON_SPACING + 20), 40, 20, I18n.getInstance().translateKey("gui.sound_test.button.reload")))
+        add(new ListenerButtonElement(32, 40 + BUTTON_SPACING * 3, bottom - (BUTTON_SPACING + 20), 40, 20, I18n.getInstance().translateKey("gui.sound_test.button.reload")))
             .setActionListener(() -> {
                 mc.sndManager = new SoundEngine();
                 mc.sndManager.init(mc.gameSettings);
                 initRepos();
             });
 
-        GuiListenerTextField volumeField = new GuiListenerTextField(parentScreen, mc.fontRenderer, width - BUTTON_SPACING - 60, bottom - (BUTTON_SPACING + 20) * 3, 60, 20, String.valueOf(volume), "Volume");
+        ListenerTextFieldElement volumeField = new ListenerTextFieldElement(parentScreen, mc.font, width - BUTTON_SPACING - 60, bottom - (BUTTON_SPACING + 20) * 3, 60, 20, String.valueOf(volume), "Volume");
         add(volumeField)
             .setPrefaceText("Vol: ")
             .setKeyListener(key -> {
@@ -120,7 +120,7 @@ public class GuiSoundTest extends GuiScreen{
                     volume = 1;
                 }});
 
-        GuiListenerTextField pitchField = new GuiListenerTextField(parentScreen, mc.fontRenderer, width - BUTTON_SPACING - 60, bottom - (BUTTON_SPACING + 20) * 4, 60, 20, String.valueOf(pitch), "Pitch");
+        ListenerTextFieldElement pitchField = new ListenerTextFieldElement(parentScreen, mc.font, width - BUTTON_SPACING - 60, bottom - (BUTTON_SPACING + 20) * 4, 60, 20, String.valueOf(pitch), "Pitch");
         add(pitchField)
             .setPrefaceText("Pitch: ")
             .setKeyListener(key -> {
@@ -134,11 +134,11 @@ public class GuiSoundTest extends GuiScreen{
                 }});
     }
 
-    protected void buttonPressed(GuiButton button)
+    protected void buttonClicked(ButtonElement button)
     {
     }
 
-    protected void buttonReleased(GuiButton button)
+    protected void buttonReleased(ButtonElement button)
     {
     }
 
@@ -149,35 +149,35 @@ public class GuiSoundTest extends GuiScreen{
         entryIndex = index;
     }
 
-    public void drawScreen(int mouseX, int mouseY, float partialTick) {
-        drawDefaultBackground();
+    public void render(int xm, int ym, float partialTick) {
+        renderBackground();
 
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
 
-        fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.sound_test.label.title"), width/2, 5, 0xFFFFFF);
+        font.drawCenteredString(I18n.getInstance().translateKey("gui.sound_test.label.title"), width/2, 5, 0xFFFFFF);
 
         String msg = I18n.getInstance().translateKey("gui.sound_test.label.select_entry");
-        fontRenderer.drawString(msg, leftEntry.getX() - BUTTON_SPACING - fontRenderer.getStringWidth(msg), leftEntry.getY() + 6, 0xFFFFFF);
+        font.drawString(msg, leftEntry.getX() - BUTTON_SPACING - font.getStringWidth(msg), leftEntry.getY() + 6, 0xFFFFFF);
 
         StringBuilder builder = new StringBuilder();
-        builder.append(fontRenderer.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.id", currentEntry == null ? null : currentEntry.getEventID()), width - 10)).append("\n");
-//        builder.append(fontRenderer.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.name", currentEntry == null ? null : currentEntry.name), width - 10)).append("\n");
+        builder.append(font.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.id", currentEntry == null ? null : currentEntry.getEventID()), width - 10)).append("\n");
+        builder.append(font.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.subtitle", currentEntry == null ? null : currentEntry.getSubtitleKey(), currentEntry == null ? null : currentEntry.getSubtitleTranslated()), width - 10)).append("\n");
 //        builder.append(fontRenderer.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.url", String.valueOf(currentEntry == null ? null : (showURL ? currentEntry.url : "REDACTED"))), width - 10)).append("\n");
         String[] lines = builder.toString().split("\n");
         int y = top + 30;
         for (String line : lines) {
-            fontRenderer.drawString(line, 5, y, 0xBBBBBB);
+            font.drawString(line, 5, y, 0xBBBBBB);
             y += 10;
         }
     }
     @Override
-    public void drawDefaultBackground() {
-        super.drawDefaultBackground();
+    public void renderBackground() {
+        super.renderBackground();
 
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
@@ -211,7 +211,7 @@ public class GuiSoundTest extends GuiScreen{
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/GuiStats.java b/src/main/java/net/minecraft/client/gui/StatsScreen.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/GuiStats.java
rename to src/main/java/net/minecraft/client/gui/StatsScreen.java
index 67b936327..61c6b52fa 100644
--- a/src/main/java/net/minecraft/client/gui/GuiStats.java
+++ b/src/main/java/net/minecraft/client/gui/StatsScreen.java
@@ -15,15 +15,15 @@ import org.lwjgl.opengl.GL12;
 
 import java.util.*;
 
-public class GuiStats extends GuiScreen {
+public class StatsScreen extends Screen {
     private static final int STATS_ICON_SIZE = 18;
     private static final int COLUMN_BUTTON_SIZE = 36;
     private static final int COLUMN0_RIGHT = 115;
     private static final int COLUMN1_RIGHT = 165;
     private static final int COLUMN2_RIGHT = 215;
 
-    protected GuiScreen parent;
-    protected GuiTooltip tooltip;
+    protected Screen parent;
+    protected TooltipElement tooltip;
     protected String title;
     private GeneralStatisticsList generalStatisticsList;
     private ItemStatisticsList itemStatisticsList;
@@ -31,13 +31,13 @@ public class GuiStats extends GuiScreen {
     private final StatsCounter statsCounter;
     private ScrolledSelectionList selectionList;
 
-    public GuiStats(GuiScreen parent, StatsCounter statsCounter)
+    public StatsScreen(Screen parent, StatsCounter statsCounter)
     {
         title = I18n.getInstance().translateKey("gui.statistics.label.title");
         selectionList = null;
         this.parent = parent;
         this.statsCounter = statsCounter;
-        tooltip = new GuiTooltip(Minecraft.getMinecraft(this));
+        tooltip = new TooltipElement(Minecraft.getMinecraft(this));
     }
 
     @Override
@@ -53,24 +53,24 @@ public class GuiStats extends GuiScreen {
     public void createButtons()
     {
         I18n i18n = I18n.getInstance();
-        controlList.add(new GuiButton(0, width / 2 + 4, height - 28, 150, 20, i18n.translateKey("gui.statistics.button.done")));
-        controlList.add(new GuiButton(1, width / 2 - 154, height - 52, 100, 20, i18n.translateKey("gui.statistics.button.general")));
-        GuiButton guibutton;
-        controlList.add(guibutton = new GuiButton(2, width / 2 - 46, height - 52, 100, 20, i18n.translateKey("gui.statistics.button.blocks")));
-        GuiButton guibutton1;
-        controlList.add(guibutton1 = new GuiButton(3, width / 2 + 62, height - 52, 100, 20, i18n.translateKey("gui.statistics.button.items")));
+        buttons.add(new ButtonElement(0, width / 2 + 4, height - 28, 150, 20, i18n.translateKey("gui.statistics.button.done")));
+        buttons.add(new ButtonElement(1, width / 2 - 154, height - 52, 100, 20, i18n.translateKey("gui.statistics.button.general")));
+        ButtonElement blocksButton;
+        buttons.add(blocksButton = new ButtonElement(2, width / 2 - 46, height - 52, 100, 20, i18n.translateKey("gui.statistics.button.blocks")));
+        ButtonElement itemsButton;
+        buttons.add(itemsButton = new ButtonElement(3, width / 2 + 62, height - 52, 100, 20, i18n.translateKey("gui.statistics.button.items")));
         if(blockStatisticsList.getItemCount() == 0)
         {
-            guibutton.enabled = false;
+            blocksButton.enabled = false;
         }
         if(itemStatisticsList.getItemCount() == 0)
         {
-            guibutton1.enabled = false;
+            itemsButton.enabled = false;
         }
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if(!button.enabled)
         {
@@ -78,7 +78,7 @@ public class GuiStats extends GuiScreen {
         }
         if(button.id == 0)
         {
-            mc.displayGuiScreen(parent);
+            mc.displayScreen(parent);
         } else
         if(button.id == 1)
         {
@@ -95,11 +95,11 @@ public class GuiStats extends GuiScreen {
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
-        selectionList.render(mouseX, mouseY, partialTick);
-        drawStringCentered(fontRenderer, title, width / 2, 20, 0xffffff);
-        super.drawScreen(mouseX, mouseY, partialTick);
+        selectionList.render(xm, ym, partialTick);
+        drawStringCentered(font, title, width / 2, 20, 0xffffff);
+        super.render(xm, ym, partialTick);
     }
 
     private void renderItemAsIcon(int x, int y, int itemID)
@@ -108,7 +108,7 @@ public class GuiStats extends GuiScreen {
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         Lighting.enableInventoryLight();
         Item item = Item.itemsList[itemID];
-        ItemModelDispatcher.getInstance().getDispatch(item).renderItemIntoGui(Tessellator.instance, fontRenderer, mc.renderEngine, item.getDefaultStack(), x + 2, y + 2, 1F);
+        ItemModelDispatcher.getInstance().getDispatch(item).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, item.getDefaultStack(), x + 2, y + 2, 1F);
         Lighting.disable();
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
@@ -151,7 +151,7 @@ public class GuiStats extends GuiScreen {
         @Override
         protected void renderHoleBackground()
         {
-            drawDefaultBackground();
+            renderBackground();
         }
 
         @Override
@@ -236,11 +236,11 @@ public class GuiStats extends GuiScreen {
             if(statItem != null)
             {
                 String s = statItem.getFormattedValue(statsCounter.readStat(statItem));
-                drawString(fontRenderer, s, x - fontRenderer.getStringWidth(s), y + 5, white ? 0xffffff : 0x909090);
+                drawString(font, s, x - font.getStringWidth(s), y + 5, white ? 0xffffff : 0x909090);
             } else
             {
                 String s1 = "-";
-                drawString(fontRenderer, s1, x - fontRenderer.getStringWidth(s1), y + 5, white ? 0xffffff : 0x909090);
+                drawString(font, s1, x - font.getStringWidth(s1), y + 5, white ? 0xffffff : 0x909090);
             }
         }
 
@@ -341,16 +341,16 @@ public class GuiStats extends GuiScreen {
         @Override
         protected void renderHoleBackground()
         {
-            drawDefaultBackground();
+            renderBackground();
         }
 
         @Override
         protected void renderItem(int index, int x, int y, int height, Tessellator tessellator)
         {
             Stat stat = StatList.basicStats.get(index);
-            drawString(fontRenderer, stat.getStatName(), x + 2, y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
+            drawString(font, stat.getStatName(), x + 2, y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
             String s = stat.getFormattedValue(statsCounter.readStat(stat));
-            drawString(fontRenderer, s, (x + 2 + 213) - fontRenderer.getStringWidth(s), y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
+            drawString(font, s, (x + 2 + 213) - font.getStringWidth(s), y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java b/src/main/java/net/minecraft/client/gui/SwitchElement.java
similarity index 80%
rename from src/main/java/net/minecraft/client/gui/GuiSwitchButton.java
rename to src/main/java/net/minecraft/client/gui/SwitchElement.java
index 3400102ce..582577ffc 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java
+++ b/src/main/java/net/minecraft/client/gui/SwitchElement.java
@@ -1,18 +1,18 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.lwjgl.opengl.GL11;
 
-public class GuiSwitchButton
-    extends GuiButton {
+public class SwitchElement
+    extends ButtonElement {
     private final String onText;
     private final String offText;
 
     private boolean on;
 
-    public GuiSwitchButton(int id, int xPosition, int yPosition, boolean on, String onText, String offText) {
+    public SwitchElement(int id, int xPosition, int yPosition, boolean on, String onText, String offText) {
         super(id, xPosition, yPosition, "");
 
         this.on = on;
@@ -21,7 +21,7 @@ public class GuiSwitchButton
         updateText();
     }
 
-    public GuiSwitchButton(int id, int xPosition, int yPosition, int width, int height, boolean on, String onText, String offText) {
+    public SwitchElement(int id, int xPosition, int yPosition, int width, int height, boolean on, String onText, String offText) {
         super(id, xPosition, yPosition, width, height, "");
 
         this.on = on;
@@ -51,7 +51,7 @@ public class GuiSwitchButton
     public void drawButton(Minecraft mc, int mouseX, int mouseY) {
         if (!visible) return;
 
-        FontRenderer fontrenderer = mc.fontRenderer;
+        Font font = mc.font;
         boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         int state = getButtonState(mouseOver);
         int xBar = on ? (width / 3) + 1 : 0;
@@ -91,6 +91,6 @@ public class GuiSwitchButton
                 textColor = 0xFFFFA0;
                 break;
         }
-        drawStringCentered(fontrenderer, displayString, xPosition + xBar + width / 3, yPosition + (height - 8) / 2, textColor);
+        drawStringCentered(font, displayString, xPosition + xBar + width / 3, yPosition + (height - 8) / 2, textColor);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiTextField.java b/src/main/java/net/minecraft/client/gui/TextFieldElement.java
similarity index 75%
rename from src/main/java/net/minecraft/client/gui/GuiTextField.java
rename to src/main/java/net/minecraft/client/gui/TextFieldElement.java
index 140320b76..fe042f86e 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTextField.java
+++ b/src/main/java/net/minecraft/client/gui/TextFieldElement.java
@@ -1,15 +1,15 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.gui.text.TextFieldEditor;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.gui.text.ITextField;
 
-public class GuiTextField extends Gui implements ITextField
+public class TextFieldElement extends Gui implements ITextField
 {
 	
-    private final FontRenderer fontRenderer;
+    private final Font font;
     public int xPosition;
     public int yPosition;
     public final int width;
@@ -19,18 +19,18 @@ public class GuiTextField extends Gui implements ITextField
     private int cursorCounter;
     public boolean isFocused;
     public boolean isEnabled;
-    public GuiScreen parent;
+    public Screen parent;
 	private ITextChangeListener textChangeListener;
     private String placeholder;
     public boolean drawBackground = true;
     private TextFieldEditor editor;
 
-    public GuiTextField(GuiScreen parent, FontRenderer fontrenderer, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
+    public TextFieldElement(Screen parent, Font font, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
     {
         isFocused = false;
         isEnabled = true;
         this.parent = parent;
-        fontRenderer = fontrenderer;
+        this.font = font;
         this.xPosition = xPosition;
         this.yPosition = yPosition;
         this.width = width;
@@ -112,40 +112,40 @@ public class GuiTextField extends Gui implements ITextField
         }
         if (text.isEmpty() && !isFocused)
         {
-            drawString(fontRenderer, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
+            drawString(font, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
         }
 
         if(isEnabled)
         {
             boolean drawCursor = isFocused && (cursorCounter / 6) % 2 == 0;
             int cursor = editor.getCursor();
-            int maxDisplayableChars = this.width / fontRenderer.getCharWidth('_');
+            int maxDisplayableChars = this.width / font.getCharWidth('_');
 
             if(text.length() <= maxDisplayableChars-1){
-                drawString(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                drawString(font, text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
             } else {
                 //only draw the part of the string that's maxDisplayableChars chars around the cursor
                 int begin = Math.max(0,cursor - maxDisplayableChars);
                 int end = Math.max(maxDisplayableChars,Math.min(text.length(),cursor));
-                drawString(fontRenderer, text.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                drawString(font, text.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
             }
             if (drawCursor)
             {
-                int width = fontRenderer.getStringWidth(text);
+                int width = font.getStringWidth(text);
                 if (cursor < text.length())
                 {
-                    width = fontRenderer.getStringWidth(text.substring(0, cursor));
+                    width = font.getStringWidth(text.substring(0, cursor));
                 }
                 if(width >= this.width-4){
                     // width of the text box - the width of the last character
-                    width = (this.width-4) - fontRenderer.getStringWidth(text.substring(text.length()-2,text.length()-1));
+                    width = (this.width-4) - font.getStringWidth(text.substring(text.length()-2,text.length()-1));
                 }
-                drawString(fontRenderer, "_", xPosition + 4 + width, yPosition + (height - 8) / 2, 0xE0E0E0);
+                drawString(font, "_", xPosition + 4 + width, yPosition + (height - 8) / 2, 0xE0E0E0);
             }
         }
         else
         {
-            drawString(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
+            drawString(font, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
         }
     }
 
@@ -165,6 +165,6 @@ public class GuiTextField extends Gui implements ITextField
 
     public interface ITextChangeListener
     {
-    	void textChanged(GuiTextField textField);
+    	void textChanged(TextFieldElement textField);
     }
 }
